# $Id: asterisk.spec,v 1.2 2003/09/19 14:28:24 dude Exp $

# The user and group names
%define uname %{name}
%define gname %{name}

Summary: PBX and telephony toolkit.
Name: asterisk
Version: 0.5.0
Release: 3.fr
License: GPL
Group: Applications/Internet
Source0: ftp://ftp.asterisk.org/pub/telephony/%{name}/%{name}-%{version}.tar.gz
Source1: %{name}.init
URL: http://www.asterisk.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: openssl, zlib, perl, speex
Requires: gtk+, mysql, newt, ncurses
BuildRequires: openssl-devel, zlib-devel, perl, speex-devel
BuildRequires: gtk+-devel, mysql-devel, newt-devel, ncurses-devel

%description
Asterisk is an Open Source PBX and telephony development platform that
can both replace a conventional PBX and act as a platform for developing
custom telephony applications for delivering dynamic content over a
telephone similarly to how one can deliver dynamic content through a
web browser using CGI and a web server.
 
Asterisk talks to a variety of telephony hardware including BRI, PRI,
POTS, and IP telephony clients using the Inter-Asterisk eXchange
protocol (e.g. gnophone or miniphone).

%prep
%setup -q

%build
# Replace /var/run by /var/run/asterisk since we don't run as root
perl -pi -e 's|ASTVARRUNDIR=\$(INSTALL_PREFIX)/var/run|ASTVARRUNDIR=\$(INSTALL_PREFIX)/var/run/%{name}|g' Makefile
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install INSTALL_PREFIX=%{buildroot}
install -D -m 0755 %{SOURCE1} %{buildroot}%{_initrddir}/%{name}
strip %{buildroot}%{_libdir}/%{name}/modules/*.so

# Override wrong absolute links
rm -f %{buildroot}%{_localstatedir}/lib/%{name}/sounds/vm && \
    ln -sf ../../../spool/%{name}/vm \
           %{buildroot}%{_localstatedir}/lib/%{name}/sounds/vm
rm -f %{buildroot}%{_localstatedir}/lib/%{name}/sounds/voicemail && \
    ln -sf ../../../spool/%{name}/voicemail \
           %{buildroot}%{_localstatedir}/lib/%{name}/sounds/voicemail
rm -f %{buildroot}%{_localstatedir}/spool/%{name}/vm && \
    ln -sf voicemail/default \
           %{buildroot}%{_localstatedir}/spool/%{name}/vm

# Install all sample config files
for file in configs/*; do
    install -m 0640 $file \
        %{buildroot}%{_sysconfdir}/%{name}/`basename $file .sample`
done

# We need that directory, see above
mkdir -p %{buildroot}%{_localstatedir}/run/%{name}

# Fix the safe_asterix script, to be run as non-root
perl -pi -e 's|asterisk \${ASTARGS}|%{_sbindir}/asterisk \${ASTARGS}|g' \
    %{buildroot}%{_sbindir}/safe_asterisk

%clean
rm -rf %{buildroot}

%pre
# Add the "%{name}" user
/usr/sbin/useradd -c "Asterisk PBX" -G tty -s /sbin/nologin -r \
    -d "%{_localstatedir}/lib/%{name}" %{uname} 2>/dev/null || :

%post
# Register the %{name} service
/sbin/chkconfig --add %{name}
# Fix the permission on tty9
/bin/chmod g+r /dev/tty9

%preun
if [ $1 -eq 0 ]; then
    /sbin/service %{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi

%files
%defattr(-, root, root, 0755)
%doc BUGS ChangeLog CREDITS HARDWARE LICENSE README SECURITY doc/ configs/
%doc sounds.txt
%dir %{_sysconfdir}/%{name}
%attr(640, %{uname}, %{gname}) %config(noreplace) %{_sysconfdir}/%{name}/*.conf
%attr(640, %{uname}, %{gname}) %config(noreplace) %{_sysconfdir}/%{name}/*.adsi
%{_initrddir}/%{name}
%{_includedir}/%{name}
%{_libdir}/%{name}
%{_sbindir}/*
%attr(-  , %{uname}, %{gname}) %{_localstatedir}/lib/%{name}
%attr(750, %{uname}, %{gname}) %{_localstatedir}/run/%{name}
%attr(750, %{uname}, %{gname}) %dir %{_localstatedir}/log/%{name}
%attr(750, %{uname}, %{gname}) %dir %{_localstatedir}/spool/%{name}
                                    %{_localstatedir}/spool/%{name}/vm
%attr(750, %{uname}, %{gname}) %dir %{_localstatedir}/spool/%{name}/voicemail
%attr(750, %{uname}, %{gname}) %dir %{_localstatedir}/spool/%{name}/voicemail/default

%changelog
* Fri Sep 19 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Initial RPM release.

